#include <string.h>

#include "as31glue.h"
#include "printf.h"
#include "paulmon2.h"
#include "display.h"
#include "malloc.h"
#include "dirlist.h"
#include "playlist.h"
#include "stricmp.h"
#include "rand.h"
#include "main.h"

simm_id current_playlist;
simm_id first_playlist;
simm_id last_playlist;
#pragma NOGCSE

void playlist_init(void)
{
  first_playlist=0;
  last_playlist=0;
  current_playlist=0;
}


extern data simm_id temp_id;

void playlist_create(simm_id pl_name) 
{
  // simm_id temp_id;
  playlist_list_t * pl_l_struct;

  temp_id = simm_malloc((unsigned int)(sizeof(struct playlist_list_struct)));

  if(first_playlist == 0)
    {
      first_playlist = temp_id;
      last_playlist = temp_id;
      pl_l_struct = addr6(temp_id);
      pl_l_struct->prev_sequential = 0;
    }
  else
    {
      pl_l_struct = addr6(last_playlist);
      pl_l_struct->next_sequential = temp_id;
      pl_l_struct = addr6(temp_id);
      pl_l_struct->prev_sequential = last_playlist;
      last_playlist = temp_id;
    }
  current_playlist = temp_id;
  pl_l_struct->next_sequential = 0;
  pl_l_struct->playlist_start_sequential = 0;
  pl_l_struct->playlist_end_sequential = 0;
  pl_l_struct->num_files = 0;
  pl_l_struct->name = pl_name;
  //printf("playlist %s created\r\n", addr6(pl_name));
}


void playlist_add_file(simm_id /* struct filelist_struct */ fl_rec) // Add file to current playlist
{
  // xdata simm_id temp_id;
  playlist_list_t * pl_l_struct;
  playlist_t * pl_struct;
 
  pl_l_struct = addr6(current_playlist);
  pl_l_struct->num_files++;

  temp_id = simm_malloc((unsigned int)(sizeof(struct playlist_struct)));
  if (pl_l_struct->playlist_start_sequential == 0)
    {
      pl_l_struct->playlist_start_sequential = temp_id;
      pl_l_struct->playlist_end_sequential = temp_id;
      pl_struct = addr7(temp_id);
      memset(pl_struct, 0, sizeof(struct playlist_struct));
      pl_struct->prev_sequential = 0;  // done by memset
    }
  else
    {
      pl_struct = addr7(pl_l_struct->playlist_end_sequential);
      pl_struct->next_sequential = temp_id; 
      pl_struct = addr7(temp_id);
      memset(pl_struct, 0, sizeof(struct playlist_struct));
      pl_struct->prev_sequential = pl_l_struct->playlist_end_sequential;
      pl_l_struct->playlist_end_sequential = temp_id;
    }
  pl_struct->playlist = current_playlist;
  pl_struct->next_sequential = 0;  // done by memset
  pl_struct->fl_rec = fl_rec;
}


void playlist_show(void) // Shows the Current Playlist
{
  playlist_t * pl_struct;
  filelist_t * fl_struct;
  
  temp_id = ((playlist_list_t *)addr7(current_playlist))->playlist_start_sequential;
  while(temp_id != 0)
    {
      pl_struct = addr6(temp_id);
      fl_struct = addr7(pl_struct->fl_rec);
      print_str(addr6(fl_struct->long_name));
      print_crlf();
      temp_id = ((playlist_t *)addr6(temp_id))->next_sequential;
    }
}









void playlist_show_all() // Show all playlists
{
  playlist_list_t * pl_l_struct;

  current_playlist = first_playlist;
  while(current_playlist != 0)
    {
      pl_l_struct = addr6(current_playlist);
      print("\r\nPlaylist ");
      print_str(addr7(pl_l_struct->name));
      printf("(%s)",addr7(pl_l_struct->name)); // seems to print junk unless I do this
      print_crlf();
      playlist_show();
      print_crlf();
      pl_l_struct = addr6(current_playlist);
      current_playlist = pl_l_struct->next_sequential;
    }
  current_playlist = first_playlist; // Reset to first
}









simm_id next_file_ptr(playlist_t *p)
{
	switch (play_mode) {
	  case MODE_DIRONLY:	// sequential within one directory
	  case MODE_SEQNTIAL:	// sequential among all directories
	  case MODE_PLSTRAND:	// seq within each dir, choose dirs randomly
		if (p->next_sequential) {
			return p->next_sequential;
		} else {
			return next_playlist_ptr(p);
		}
	  case MODE_DIRRAND:	// randomly choose files within 1 dir
	  case MODE_ALLRAND:	// randomly choose files among all dirs
		return p->next_random;
	  default:
		break;
	}
}

simm_id prev_file_ptr(playlist_t *p)
{
	switch (play_mode) {
	  case MODE_DIRONLY:	// sequential within one directory
	  case MODE_SEQNTIAL:	// sequential among all directories
	  case MODE_PLSTRAND:	// seq within each dir, choose dirs randomly
		if (p->prev_sequential) {
			return p->prev_sequential;
		} else {
			return prev_playlist_ptr(p);
		}
	  case MODE_DIRRAND:	// randomly choose files within 1 dir
	  case MODE_ALLRAND:	// randomly choose files among all dirs
		return p->prev_random;
	  default:
		break;
	}
}


simm_id next_playlist_ptr(playlist_t *p)
{
	switch (play_mode) {
	  case MODE_DIRONLY:	// sequential within one directory
	  case MODE_SEQNTIAL:	// sequential among all directories
	  case MODE_DIRRAND:	// randomly choose files within 1 dir
		return ((playlist_list_t *)addr6(((playlist_list_t *)addr6(p->playlist))->next_sequential))->playlist_start_sequential;

	  case MODE_PLSTRAND:	// seq within each dir, choose dirs randomly
	  case MODE_ALLRAND:	// randomly choose files among all dirs
		return ((playlist_list_t *)addr6(((playlist_list_t *)addr6(p->playlist))->next_random))->playlist_start_sequential;

	  default:
		break;
	}
}

simm_id prev_playlist_ptr(playlist_t *p)
{
	switch (play_mode) {
	  case MODE_DIRONLY:	// sequential within one directory
	  case MODE_SEQNTIAL:	// sequential among all directories
	  case MODE_DIRRAND:	// randomly choose files within 1 dir
		return ((playlist_list_t *)addr6(((playlist_list_t *)addr6(p->playlist))->prev_sequential))->playlist_start_sequential;

	  case MODE_PLSTRAND:	// seq within each dir, choose dirs randomly
	  case MODE_ALLRAND:	// randomly choose files among all dirs
		return ((playlist_list_t *)addr6(((playlist_list_t *)addr6(p->playlist))->prev_random))->playlist_start_sequential;

	  default:
		break;
	}
}









playlist_list_t *current_playlist_ptr;
bit first_rand;


void playlist_show_rand(void) // Shows the Current Playlist (randomized)
{
	playlist_t * pl_struct;
 
	temp_id = ((playlist_list_t *)addr6(current_playlist))->playlist_start_random;
	pl_struct = (playlist_t *)addr6(temp_id);
	while (1) {
		print_hex32(simm_id_from_pointer(pl_struct));
		print_hex32(pl_struct->prev_random);
		print_hex32(pl_struct->next_random);
		print_hex32(temp_id);
		print_str((xdata char *)addr7(((filelist_t *)addr7(pl_struct->fl_rec))->long_name));
		print_crlf();
		if (pl_struct->next_random == temp_id) break;
		pl_struct = (playlist_t *)addr6(pl_struct->next_random);
	}
	print_crlf();
}




playlist_t * choose_one_file_randomly(unsigned int n)
{
	unsigned int count;
	playlist_t *entry;

	entry = addr7(current_playlist_ptr->playlist_start_sequential);
	count = rand16() % n;
	while (1) {
		if (!entry->is_randomized) {
			if (count == 0) {
				print_crlf();
				return entry;
			}
			count--;
		}
		entry = addr7(entry->next_sequential);
	}
}



void randomize_one_playlist(simm_id /* playlist_list_t */ list_id)
{
	playlist_t *entry;
	unsigned int n, num_files=0;
	static simm_id last_rand_entry;

	current_playlist_ptr = (playlist_list_t *)addr6(list_id);

	/* mark all files as not randomized */
	temp_id = current_playlist_ptr->playlist_start_sequential;
	while (temp_id) {
		entry = (playlist_t *)addr7(temp_id);
		entry->is_randomized = 0;
		temp_id = entry->next_sequential;
		num_files++;
	}

	printf("Randomizing %d files...\r\n", num_files);

	first_rand=1;
	for (n=num_files; n>0; n--) {
		entry = choose_one_file_randomly(n);
		entry->is_randomized = 1;

		if (first_rand) {
			last_rand_entry =
			  current_playlist_ptr->playlist_start_random =
			  simm_id_from_pointer(entry);
			first_rand = 0;
		} else {
			entry->prev_random = last_rand_entry;
			temp_id = simm_id_from_pointer(entry);
			last_rand_entry =
			  ((playlist_t *)addr7(last_rand_entry))->next_random =
			  temp_id;
		}
	}

	((playlist_t *)addr7(last_rand_entry))->next_random =
	   current_playlist_ptr->playlist_start_random;
	((playlist_t *)addr7(current_playlist_ptr->playlist_start_random))->prev_random = last_rand_entry;
}
